var argusStatsConstructor = function (option) {
    option = option || {};

    var ArgusStats;
    // store the event which was create in  App.onXX or Page.onXX functions.
    var event_array = [];
    var eventCacheSize = argusStatsConstructor.EVENT_CACHESIZE;

    var jserror_cache_size = argusStatsConstructor.JSERROR_CACHE_SIZE;
    var jserror_cache = [];

    var flags = {}
    flags.get_clipboard_info_flag = false;
    flags.found_first_page_onready_flag = false;
    flags.found_app_onlauch_flag = false;
    flags.check_firstload_flag = false;
    flags.is_firstload_flag = false;
    flags.send_firstload_flag = false;
    flags.is_valid_verson = false;
    var first_page_onready_event = null;
    var app_onlauch_event = null;
    var cmd_info = null;
    


    var status = function () {
    };
    status.data_sending_flag = false;

    var title_dict = {};

    var check_is_first_load = function() {
      const fs = wx.getFileSystemManager();
      try {
        fs.mkdirSync(`${wx.env.USER_DATA_PATH}/argus_dir`);
        flags.check_firstload_flag = true;
        flags.is_firstload_flag = true;
        // console.log('mkdirSync sucess, first load');
      } catch (e) {
        flags.check_firstload_flag = true;
        flags.is_firstload_flag = false;
        // console.log('mkdirSync fail, not first load');
        // console.log(e)
      }
    };

    var send_event_data_to_wetest = function () {
      if (flags.get_clipboard_info_flag === false || 
          flags.is_valid_verson === false || 
          cmd_info === null || event_array.length === 0) {
        return
      }
      var event_count = event_array.length;
      var request_data = {
        testid: cmd_info.testid,
        deviceid: cmd_info.deviceid,
        data: JSON.stringify(event_array)
      };
      var request_header = {};
      if (typeof (cmd_info.sessionid) != 'undefined') {
        request_header.Cookie = cmd_info.sessionid;
      }
      if (typeof (cmd_info.token) != 'undefined' && typeof (cmd_info.time) != 'undefined') {
        request_data.token = cmd_info.token;
        request_data.time = cmd_info.time;
      }

      wx.request({
        url: argusStatsConstructor.WETEST_EVENT_API_URL,
        data: request_data,
        method: 'POST',
        header: request_header,
        success(res) {
          // console.log("wetest api request success")
          if (res.data['flag'] === true) {
            event_array = event_array.slice(event_count);
          } else {
            wx.showToast({
              title: 'wetest miniappEvent api fail, msg:' + res.data['msg'],
              icon: 'none'
            })
          }
        },
        fail(res) {
          wx.showToast({
            title: 'wetest miniappEvent api request fail',
            icon: 'none'
          })
        }
      })
    };

    var sendEvent = function (event) {
      // only add event into the array
      if (flags.send_firstload_flag === false && flags.check_firstload_flag 
        && flags.found_app_onlauch_flag && app_onlauch_event != null) {
        app_onlauch_event.is_firstload_flag = flags.is_firstload_flag; 
        if (event_array.length >= eventCacheSize) {
          event_array.shift();
          event_array.push(event);
        } else {
          event_array.push(event);
        }
        console.log(event);
        flags.send_firstload_flag = true;
      }
      if (flags.found_first_page_onready_flag === false) {
        if (event.event_type === 'Page' && event.event_name === 'onReady') {
          event.first_onReady_flag = true;
          flags.found_first_page_onready_flag = true;
        }
      }

      if (flags.found_app_onlauch_flag === false) {
        if (event.event_type === 'App' && event.event_name === 'onLaunch') {
          flags.found_app_onlauch_flag = true;
          if (flags.check_firstload_flag) {
            event.is_firstload_flag = flags.is_firstload_flag;
            flags.send_firstload_flag = true;
          }
          else {
            //the event will be added by 'app_onlauch_event' in the feature.
            app_onlauch_event = event;
            return;
          }
        }
      }

      if (event_array.length >= eventCacheSize) {
        event_array.shift();
        event_array.push(event);
      } else {
        event_array.push(event);
      }
      // console.log(event);
    };

    var send_jserror_data_to_wetest = function(event) {
      if (flags.get_clipboard_info_flag === false ||
        flags.is_valid_verson === false ||
        cmd_info === null ||
        jserror_cache.length === 0) {
        return;
      }
      var jserror_count = jserror_cache.length;
      var request_data = {
        testid: cmd_info.testid,
        deviceid: cmd_info.deviceid,
        data: JSON.stringify(jserror_cache)
      };
      var request_header = {};

      if (typeof (cmd_info.sessionid) != 'undefined') {
        request_header.Cookie = cmd_info.sessionid;
      }
      if (typeof (cmd_info.token) != 'undefined' && typeof (cmd_info.time) != 'undefined') {
        request_data.token = cmd_info.token;
        request_data.time = cmd_info.time;
      }

      wx.request({
        url: argusStatsConstructor.WETEST_MINIPRGJSERROR_API_URL,
        data: request_data,
        method: 'POST',
        header: request_header,
        success(res) {
          if (res.data['flag'] == true) {
            //console.log("wetest api request success");
            // jserror_cache = [];
            jserror_cache = jserror_cache.slice(jserror_count);
          } else {
            wx.showToast({
              title: 'wetest jserror api fail, msg:' + res.data['msg'],
              icon: 'none'
            });
            //console.log("wetest api request fail1, res:" + res.data);
          }
        },
        fail(res) {
          wx.showToast({
            title: 'wetest jserror api request fail:',
            icon: 'none'
          })
          //console.log("wetest api request fail2, res:" + res.data);
        }
      });
  };

    var send_jserror = function(timestamp, error) {
      var jserror_info = { "timestamp": timestamp, "jserror": error };
      if (jserror_cache.length >= jserror_cache_size) {
        jserror_cache.shift();
        jserror_cache.push(jserror_info);
        //console.log("send_jserror: reach cache size, shift and push jserror");
      } else {
        jserror_cache.push(jserror_info);
        // console.log("send_jserror: push jserror");
      }
    };

    var hookWxApp = function () {
        // hook App
        var new_App = function () {
            var that = this;
            var index = 0;
            //console.log('new_App is called. ' + Date.now());

            // hook onLaunch
            var origin_onLaunch = arguments[0].onLaunch;
            var new_onLaunch = function () {
                //console.log('origin_onLaunch in new_App called.' + Date.now())
                var time = Date.now();
                index = index + 1;
                sendEvent({
                    event_type: 'App',
                    event_name: 'onLaunch',
                    event_index: index,
                    timestamp: time,
                    page_path: '',
                    page_title: ''
                });

                var that = this;
                if (origin_onLaunch) {
                    return origin_onLaunch.apply(that, [].slice.call(arguments));
                }
            };
            arguments[0].onLaunch = new_onLaunch;

            // hook onShow
            var origin_onShow = arguments[0].onShow;
            var new_onShow = function () {
                //console.log('origin_onShow in new_App called.' + Date.now());
                var time = Date.now();
                sendEvent({
                    event_type: 'App',
                    event_name: 'onShow',
                    event_index: index,
                    timestamp: time,
                    page_path: '',
                    page_title: ''
                });
                var that = this;
                if (origin_onShow) {
                    return origin_onShow.apply(that, [].slice.call(arguments));
                }
            };
            arguments[0].onShow = new_onShow;

            // hook onHide
            var origin_onHide = arguments[0].onHide;
            var new_onHide = function () {
                //console.log('origin_onHide in new_App called.' + Date.now());
                var time = Date.now();
                sendEvent({
                    event_type: 'App',
                    event_name: 'onHide',
                    event_index: index,
                    timestamp: time,
                    page_path: '',
                    page_title: ''
                });
                var that = this;
                if (origin_onHide) {
                    return origin_onHide.apply(that, [].slice.call(arguments));
                }
            };
            arguments[0].onHide = new_onHide;

            if (origin_App) {
                return origin_App.apply(that, [].slice.call(arguments));
            }
        };
        var origin_App = App;
        App = new_App;
    };

    var hookWxPage = function () {
        var new_Page = function () {
            var that = this;
            var index = 0;
            //console.log('new_Page called.. ' + Date.now());

            // hook onLoad
            var origin_onLoad = arguments[0].onLoad;
            var new_onLoad = function () {
                // console.log('origin_onLoad in new_Page called.' + Date.now());
                var that = this;
                var time = Date.now();
                index = index + 1;
                //console.log(__wxConfig);
                if (typeof(__wxConfig["page"][that.route + ".html"]) != 'undefined' &&
                    typeof(__wxConfig["page"][that.route + ".html"]["window"]) != 'undefined' &&
                    typeof(__wxConfig["page"][that.route + ".html"]["window"]["navigationBarTitleText"])  != 'undefined') {
                    title_dict[that.route] = __wxConfig["page"][that.route + ".html"]["window"]["navigationBarTitleText"];
                }else{
                    title_dict[that.route] = '';
                }

                sendEvent({
                    event_type: 'Page',
                    event_name: 'onLoad',
                    event_index: index,
                    timestamp: time,
                    page_path: that.route,
                    page_title: title_dict[that.route]
                });
                if (origin_onLoad) {
                    return origin_onLoad.apply(that, [].slice.call(arguments));
                }
            };
            arguments[0].onLoad = new_onLoad;

            // hook onShow
            var origin_onShow = arguments[0].onShow;
            var new_onShow = function () {
                // console.log('origin_onShow in new_Page called.' + Date.now());
                var that = this;
                var time = Date.now();
                sendEvent({
                    event_type: 'Page',
                    event_name: 'onShow',
                    event_index: index,
                    timestamp: time,
                    page_path: that.route,
                    page_title: title_dict[that.route]
                });
                if (origin_onShow) {
                    return origin_onShow.apply(that, [].slice.call(arguments));
                }
            };
            arguments[0].onShow = new_onShow;

            // hook onReady
            var origin_onReady = arguments[0].onReady;
            var new_onReady = function () {
                //console.log('origin_onReady in new_Page called.' + Date.now());
                var that = this;
                var time = Date.now();
                sendEvent({
                    event_type: 'Page',
                    event_name: 'onReady',
                    event_index: index,
                    timestamp: time,
                    page_path: that.route,
                    page_title: title_dict[that.route]
                });
                if (origin_onReady) {
                    return origin_onReady.apply(that, [].slice.call(arguments));
                }
            };
            arguments[0].onReady = new_onReady;

            // hook onHide
            var origin_onHide = arguments[0].onHide;
            var new_onHide = function () {
                //console.log('origin_onHide in new_Page called.' + Date.now());
                var that = this;
                var time = Date.now();
                sendEvent({
                    event_type: 'Page',
                    event_name: 'onHide',
                    event_index: index,
                    timestamp: time,
                    page_path: that.route,
                    page_title: title_dict[that.route]
                });
                if (origin_onHide) {
                    return origin_onHide.apply(that, [].slice.call(arguments));
                }
            };
            arguments[0].onHide = new_onHide;

            // hook onUnload
            var origin_onUnload = arguments[0].onUnload;
            var new_onUnload = function () {
                //console.log('origin_onUnload in new_Page called.' + Date.now());
                var that = this;
                var time = Date.now();
                sendEvent({
                    event_type: 'Page',
                    event_name: 'onUnload',
                    event_index: index,
                    timestamp: time,
                    page_path: that.route,
                    page_title: title_dict[that.route]
                });
                if (origin_onUnload) {
                    return origin_onUnload.apply(that, [].slice.call(arguments));
                }
            };
            arguments[0].onUnload = new_onUnload;

            if (origin_Page) {
                return origin_Page.apply(that, [].slice.call(arguments));
            }
        };

        var origin_Page = Page;
        Page = new_Page;
    };

    var hookWxSetNavigationBarTitle = function () {
        //hook wx.setNavigationBarTitle
        var origin_setNavigationBarTitle = wx.setNavigationBarTitle;
        var new_setNavigationBarTitle = function () {
            //console.log('new_setNavigationBarTitle is called.' + Date.now())
            var that = this;
            var pages = getCurrentPages();
            var current_page = pages[pages.length - 1];
            var new_title = arguments[0]["title"];
            if (typeof (current_page) != "undefined" && typeof (new_title) != "undefined") {
                if (typeof(current_page["route"]) != "undefined"){
                    title_dict[current_page["route"]] = new_title;
                }
                //console.log(current_page["route"]);
                //console.log(arguments[0]["title"]);
            }
            if (origin_setNavigationBarTitle) {
                return origin_setNavigationBarTitle.apply(that, [].slice.call(arguments));
            }
        };

        Object.defineProperty(wx, 'setNavigationBarTitle', {
            get: function () {
                //console.log('defineProperty get!');
                return new_setNavigationBarTitle;
            }
        });
    };

    var get_clipboard_cmd = function () {
      //console.log('get_clipboard_cmd called')
      flags.get_clipboard_info_flag = false;
      cmd_info = null;
      wx.getClipboardData({
        success: function (ret) {
          // check cmd in clipboard
          // console.log('clipboard: '+ret.data.substr(0,10));
          var cmds = ret.data.split('::')
          if (cmds.length === 2 && cmds[0] === '[wetest_miniapp_test]' && cmds[1]) {

            try {
              cmd_info = JSON.parse(cmds[1]);
              if (typeof (cmd_info.testid) != 'undefined' && typeof (cmd_info.deviceid) != 'undefined') {
                if (typeof (cmd_info.sessionid) != 'undefined') {
                  flags.get_clipboard_info_flag = true;
                }
                if (typeof (cmd_info.token) != 'undefined' && typeof (cmd_info.time) != 'undefined') {
                  flags.get_clipboard_info_flag = true;
                }
              }
            } catch (e) {
              flags.get_clipboard_info_flag = false;
              wx.showModal({
                title: '从剪贴板中解析json失败:',
                content: ret.data,
                showCancel: false
              });
            }
          }
          if (flags.get_clipboard_info_flag === false) {
            wx.showModal({
              title: '无法从剪贴板中获得正确信息:',
              content: ret.data,
              showCancel: false
            });
          }
        },
        fail: function (ret) {
          wx.showModal({
            title: '无法从剪贴板中获得正确信息:',
            content: '无法从剪贴板中获得正确信息',
            showCancel: false
          });
        }
      })
    };

    var check_version = function(){
      wx.request({
        url: argusStatsConstructor.WETEST_SDK_VERSION_URL,
        success(res) {
          // console.log("wetest sdk version api request success")
          if (res.data['flag'] === true) {
            try{
              var valid_version = res.data['ret']['miniapp'];
              if (valid_version === argusStatsConstructor.version) {
                flags.is_valid_verson = true;
              }else {
                flags.is_valid_verson = false;
                wx.showModal({
                  title: 'JS-SDK版本不正确',
                  content: '请到最新JS-SDK，当前版本：' + argusStatsConstructor.version + "，最新版本：" + valid_version,
                  showCancel: false
                });
              }
            } catch (e) {
              wx.showModal({
                title: 'JS-SDK版本检测错误:',
                content: res.data,
                showCancel: false
              });
            }
          } else {
            wx.showModal({
              title: 'JS-SDK版本检测错误:',
              content: res.data,
              showCancel: false
            });
          }
        },
        fail(res) {
          wx.showModal({
            title: 'JS-SDK版本检测错误:',
            content: 'wetest jsSdkVersion api request fail',
            showCancel: false
          });
        }
      })
    };

    ArgusStats = {
      
        start: function () {
            var that = this;
            check_is_first_load();
            hookWxApp();
            hookWxPage();
            hookWxSetNavigationBarTitle();
            get_clipboard_cmd();
            check_version();
            //set wx.onError callback
            var jserror_callback = function (error) {
              send_jserror(Date.now(), error);
            }
            wx.onError(jserror_callback);
            setInterval(send_event_data_to_wetest, 1000);

            setInterval(send_jserror_data_to_wetest, 5000);
        }
    };
    
    return ArgusStats;
};

argusStatsConstructor.EVENT_CACHESIZE = 100;

argusStatsConstructor.WETEST_EVENT_API_URL = 'https://wetest.qq.com/cloud/api/miniappEvent';


argusStatsConstructor.WETEST_MINIPRGJSERROR_API_URL = 'https://wetest.qq.com/cloud/api/miniappError';
argusStatsConstructor.JSERROR_CACHE_SIZE = 100;

argusStatsConstructor.WETEST_SDK_VERSION_URL = 'https://wetest.qq.com/cloud/api/jsSdkVersion';
argusStatsConstructor.version = '1.0';


var argusStats = argusStatsConstructor();
argusStats.start();

module.exports = {
    argusStats: argusStatsConstructor
};