/*
feifanwang@20191230
*/

var FPSStats = function () {
    var beginTime = (Date || performance).now();
    var prevTime = beginTime;
    var frames = 0;
    var time_delta = 1000;

    var first_frame_time = 0;

    var canvas_2d = wx.createCanvas();
    var canvas_webgl = wx.createCanvas();

    var CanvasRenderingContext2D  = canvas_2d.getContext('2d');
    var WebGLRenderingContext = canvas_webgl.getContext('webgl');

    var fpsCacheSize = FPSStats.FPS_CHACE_SIZE; // 1: no cache; 300: cache 300 seconds
    var fpsCache = []; // cache array

    var jserror_cache_size = FPSStats.JSERROR_CACHE_SIZE;
    var jserror_cache = [];

    var flags = {};
    flags.engine_draw_flag = false;
    flags.engine_draw_injected_flag = false;
    flags.context_draw_injected_flag = false;
    flags.context_draw_flag = false;
    flags.get_clipboard_info_flag = false;
    flags.check_firstload_flag = false;
    flags.is_valid_verson = false;
    flags.is_firstload_flag = false;
    flags.send_firstload_flag = false;
    flags.send_first_frame_time = false;
    var cmd_info = null;


    var origin_webglcontext_drawElements = null;
    var origin_webglcontext_drawArrays = null;
    var origin_context2d_fill = null;
    var origin_context2d_fillRect = null;
    var origin_context2d_drawImage = null;

    return {
        mode: FPSStats.MODE_INIT,

        /* inject game engine draw methods */
        inject_engine_draw: function () {
            var origin_engine_draw = null;
            var new_engine_draw = function () {
                flags.engine_draw_flag = true;
                if (origin_engine_draw) {
                    return origin_engine_draw.apply(this, [].slice.call(arguments));
                }
            };

            var origin_engine_draw_2 = null;
            var new_engine_draw_2 = function () {
                flags.engine_draw_flag = true;
                if (origin_engine_draw_2) {
                    return origin_engine_draw_2.apply(this, [].slice.call(arguments));
                }
            };

            if (!flags.engine_draw_injected_flag) {
                if (typeof (Laya) != 'undefined') {
                    if (typeof (Laya.Scene) != 'undefined') {
                        origin_engine_draw = Laya.Scene.prototype._updateScene;
                        Laya.Scene.prototype._updateScene = new_engine_draw;
                        flags.engine_draw_injected_flag = true;
                    }
                    if (typeof (Laya.stage) != 'undefined' &&
                        Laya.stage != null && typeof (Laya.stage._loop) != 'undefined') {
                        origin_engine_draw_2 = Laya.stage._loop;
                        Laya.stage._loop = new_engine_draw_2;
                        flags.engine_draw_injected_flag = true;
                    }
                } else if (typeof (cc) != 'undefined' && typeof (cc.director) != 'undefined') {
                    origin_engine_draw = cc.director.mainLoop;
                    cc.director.mainLoop = new_engine_draw;
                    flags.engine_draw_injected_flag = true;
                } else if (typeof (egret) != 'undefined') {
                    if (typeof (egret.sys) != 'undefined' && typeof (egret.sys.$ticker) != 'undefined') {
                        origin_engine_draw = egret.sys.$ticker.render;
                        egret.sys.$ticker.render = new_engine_draw;
                        flags.engine_draw_injected_flag = true;
                    }
                    if (typeof (egret.ticker) != 'undefined') {
                        origin_engine_draw_2 = egret.ticker.render;
                        egret.ticker.render = new_engine_draw_2;
                        flags.engine_draw_injected_flag = true;
                    }
                }
            }else{
                console.log("[Argus]no need to inject engine update again");
            }
        },

        inject_context_draw:function () {
            console.log("[Argus]try to inject context_draw");

            if (WebGLRenderingContext === null || CanvasRenderingContext2D === null){
                console.log("[Argus]can not to inject context_draw.");
                return
            }

            if (!flags.context_draw_injected_flag) {
                //inject WebGLRenderingContext draw methods
                var new_webglcontext_drawElements = function () {
                    flags.context_draw_flag = true;
                    if (origin_webglcontext_drawElements) {
                        return origin_webglcontext_drawElements.apply(this, [].slice.call(arguments));
                    }
                };
                origin_webglcontext_drawElements = WebGLRenderingContext.__proto__.drawElements;
                WebGLRenderingContext.__proto__.drawElements = new_webglcontext_drawElements;

                var new_webglcontext_drawArrays = function () {
                    flags.context_draw_flag = true;
                    if (origin_webglcontext_drawArrays) {
                        return origin_webglcontext_drawArrays.apply(this, [].slice.call(arguments));
                    }
                };
                origin_webglcontext_drawArrays = WebGLRenderingContext.__proto__.drawArrays;
                WebGLRenderingContext.__proto__.drawArrays = new_webglcontext_drawArrays;


                //inject CanvasRenderingContext2D draw methods
                var new_context2d_fill = function () {
                    flags.context_draw_flag = true;
                    if (origin_context2d_fill) {
                        return origin_context2d_fill.apply(this, [].slice.call(arguments));
                    }
                };
                origin_context2d_fill = CanvasRenderingContext2D.__proto__.fill;
                CanvasRenderingContext2D.__proto__.fill = new_context2d_fill;

                var new_context2d_fillRect = function () {
                    flags.context_draw_flag = true;
                    if (origin_context2d_fillRect) {
                        return origin_context2d_fillRect.apply(this, [].slice.call(arguments));
                    }
                };
                origin_context2d_fillRect = CanvasRenderingContext2D.__proto__.fillRect;
                CanvasRenderingContext2D.__proto__.fillRect = new_context2d_fillRect;

                var new_context2d_drawImage = function () {
                    flags.context_draw_flag = true;
                    if (origin_context2d_drawImage) {
                        return origin_context2d_drawImage.apply(this, [].slice.call(arguments));
                    }
                };
                origin_context2d_drawImage = CanvasRenderingContext2D.__proto__.drawImage;
                CanvasRenderingContext2D.__proto__.drawImage = new_context2d_drawImage;

                flags.context_draw_injected_flag = true;
                console.log("[Argus]inject context_draw completed");
            }else{
                console.log("[Argus]no need to inject context_draw again");
            }
        },

        recover_context_draw: function () {
            console.log("[Argus]try to recover context_draw");

            if (WebGLRenderingContext === null || CanvasRenderingContext2D === null){
                console.log("[Argus]can not to recover context_draw.");
                return
            }

            if (flags.context_draw_injected_flag) {
                //recover WebGLRenderingContext draw methods

                if (origin_webglcontext_drawElements){
                    WebGLRenderingContext.__proto__.drawElements = origin_webglcontext_drawElements;
                }
                if (origin_webglcontext_drawArrays){
                    WebGLRenderingContext.__proto__.drawArrays = origin_webglcontext_drawArrays;
                }

                //recover CanvasRenderingContext2D draw methods
                if (origin_context2d_fill){
                    CanvasRenderingContext2D.__proto__.fill = origin_context2d_fill;
                }
                if (origin_context2d_fillRect) {
                    CanvasRenderingContext2D.__proto__.fillRect = origin_context2d_fillRect;
                }
                if (origin_context2d_drawImage) {
                    CanvasRenderingContext2D.__proto__.drawImage = origin_context2d_drawImage;
                }

                flags.context_draw_injected_flag = false;
                console.log("[Argus]recover context_draw completed");
            }else{
                console.log("[Argus]no need to recover context_draw");
            }

        },
      check_is_first_load: function () {
        const fs = wx.getFileSystemManager();
        try {
          fs.mkdirSync(`${wx.env.USER_DATA_PATH}/argus_dir`);
          flags.check_firstload_flag = true;
          flags.is_firstload_flag = true;
          // console.log('mkdirSync sucess, first load');
        } catch (e) {
			var flag = wx.getStorageSync("argus_is_firstload");
          if (!flag) {
            // 1. uninstall wechat 2. clear wechat data 
            // need redownload code and resource
            flags.check_firstload_flag = true;
            flags.is_firstload_flag = true;
            wx.setStorageSync("argus_is_firstload", true);
          } else {
            // code and resource cached, need not download
            flags.check_firstload_flag = true;
            flags.is_firstload_flag = false;
          }
        }
      },

      get_clipboard_cmd: function () {
        flags.get_clipboard_info_flag = false;
        cmd_info = null;
        wx.getClipboardData({
          success: function (ret) {
            // check cmd in clipboard
            // console.log('clipboard: '+ret.data.substr(0,10));
            var cmds = ret.data.split('::')
            if (cmds.length === 2 && cmds[0] === '[wetest_miniapp_test]' && cmds[1]) {
              // cmd detected, change to stat mode
              try{
                cmd_info = JSON.parse(cmds[1]);
                if (typeof (cmd_info.testid) != 'undefined' && typeof (cmd_info.deviceid) != 'undefined'){ 
                  if (typeof (cmd_info.sessionid) != 'undefined') {
                    flags.get_clipboard_info_flag = true;
                  }
                  if (typeof (cmd_info.token) != 'undefined' && typeof (cmd_info.time) != 'undefined') {
                    flags.get_clipboard_info_flag = true;
                  }
                }
              }catch(e){
                flags.get_clipboard_info_flag = false;
                wx.showModal({
                  title: '从剪贴板中解析json失败:',
                  content: ret.data,
                  showCancel: false
                });
              }
            }
            if (flags.get_clipboard_info_flag === false) {
              wx.showModal({
                title: '无法从剪贴板中获得正确信息:',
                content: ret.data,
                showCancel: false
              });
            }
          },
          fail: function (ret) {
            wx.showModal({
              title: '无法从剪贴板中获得正确信息:',
              content: '无法从剪贴板中获得正确信息',
              showCancel: false
            });
          }
        })
      },

      check_version: function () {
        wx.request({
          url: FPSStats.WETEST_SDK_VERSION_URL,
          success(res) {
            // console.log("wetest sdk version api request success")
            if (res.data['flag'] === true) {
              try {
                var valid_version = res.data['ret']['minigame'];
                if (valid_version === FPSStats.version) {
                  flags.is_valid_verson = true;
                } else {
                  flags.is_valid_verson = false;
                  wx.showModal({
                    title: 'JS-SDK版本不正确',
                    content: '请到最新JS-SDK，当前版本：' + FPSStats.version + "，最新版本：" + valid_version,
                    showCancel: false
                  });
                }
              } catch (e) {
                wx.showModal({
                  title: 'JS-SDK版本检测错误:',
                  content: res.data,
                  showCancel: false
                });
              }
            } else {
              wx.showModal({
                title: 'JS-SDK版本检测错误:',
                content: res.data,
                showCancel: false
              });
            }
          },
          fail(res) {
            wx.showModal({
              title: 'JS-SDK版本检测错误:',
              content: 'wetest jsSdkVersion api request fail',
              showCancel: false
            });
          }
        })
      },

        /* init */
        init: function () {
            var that = this;
            flags.engine_draw_flag = false;
            flags.context_draw_flag = false;

            that.inject_context_draw();
            if (flags.context_draw_injected_flag) {
                that.mode = FPSStats.MODE_STAT;
            }
            // try forever
            that.inject_engine_with_check();
            beginTime = Date.now();
            prevTime = beginTime;
            frames = 0;
            that.get_clipboard_cmd();
            that.check_is_first_load();
            that.check_version();
        },

        inject_engine_with_check: function () {
            var that = this;
            // try to inject engine update. try for ever
            var inject_and_check = function () {
                console.log("[Argus]try to inject engine update...");
                that.inject_engine_draw();

                if (flags.engine_draw_injected_flag) {
                    console.log("[Argus]inject engine update sucessed");
                    that.recover_context_draw();
                    that.mode = FPSStats.MODE_STAT;
                }else {
                    console.log("[Argus]inject engine update failed. wait 10000ms ...");
                    setTimeout(inject_and_check, 10000);
                }
            };
            inject_and_check();
        },

        /* upload fps data */
        uploadFPS: function (time, fps) {
          var that = this;
          var fpsinfo = { timestamp: time, fps: Math.round(fps)};

          // cache fps data
          // console.log(that.fpsCache.length , that.fpsCacheSize)
          if (fpsCache.length >= fpsCacheSize) {
            fpsCache.shift();
            fpsCache.push(fpsinfo);
          } else {
            fpsCache.push(fpsinfo);
          }
          if (flags.get_clipboard_info_flag === false ||
              flags.is_valid_verson === false ||
              cmd_info === null) {
            return
          }


          var fps_data = {"fps_data": fpsCache};
          
          if (flags.send_first_frame_time === false &&
            flags.send_firstload_flag === false && 
            first_frame_time != 0 && 
            flags.check_firstload_flag) {
            fps_data.first_frame = first_frame_time;
            fps_data.is_firstload_flag = flags.is_firstload_flag;
          }
          
          var request_data = {
            testid: cmd_info.testid,
            deviceid: cmd_info.deviceid,
            data: JSON.stringify(fps_data)
          };
          var request_header = {};

          if (typeof (cmd_info.sessionid) != 'undefined') {
            request_header.Cookie = cmd_info.sessionid;
          }
          if (typeof (cmd_info.token) != 'undefined' && typeof (cmd_info.time) != 'undefined') {
            request_data.token = cmd_info.token;
            request_data.time = cmd_info.time;
          }
          wx.request({
            url: FPSStats.WETEST_FPS_API_URL,
            data: request_data,
            method: 'POST',
            header: request_header,
            success(res) {
              // console.log("wetest api request success")
              if (res.data['flag'] === true) {
                fpsCache = [];
                if (typeof(fps_data.first_frame) != "undefined") {
                  flags.send_first_frame_time = true;
                }
                if (typeof (fps_data.is_firstload_flag) != "undefined") {
                  flags.send_firstload_flag = true;
                }
              }else{
                wx.showToast({
                  title: 'wetest FPS api fail, msg:' + res.data['msg'],
			      icon: 'none'
                })
              }
            },
            fail(res) {
              wx.showToast({
                title: 'wetest FPS api request fail',
			          icon: 'none'
              })
            }
          })

        },
        /* calc fps */
        calc: function () {
            var that = this;

            var time = Date.now();
            if (time > prevTime + time_delta) {
                var fps = ((frames) * time_delta) / (time - prevTime);
                prevTime = time;
                frames = 0;
                if (fps > 60){
                    fps = 60;
                }
                var msg = '[Argus][QQMini][FPS]' + time + ',' + Math.round(fps) + ',' + first_frame_time + '[StatsEnd]';
                // 只有在测试模式下才会输出FPS
                if (that.mode === FPSStats.MODE_STAT) {
                    that.uploadFPS(time, fps);
                    console.log(msg);
                }
            }

            if (flags.context_draw_flag || flags.engine_draw_flag) {
                frames++;
                if (first_frame_time === 0) {
                    first_frame_time = Date.now()
                }
            }
            flags.context_draw_flag = false;
            flags.engine_draw_flag = false;
        },

      send_jserror_data_to_wetest: function (event) {
        //console.log('send_jserror_data_to_wetest, flags.get_clipboard_info_flag:' + flags.get_clipboard_info_flag);
        //console.log('send_jserror_data_to_wetest, cmd_info:' + cmd_info);
        //console.log('send_jserror_data_to_wetest, jserror_cache.length:' + jserror_cache.length);
        //if (flags.get_clipboard_info_flag === false ||
        //  cmd_info === null) {
        //  that.get_clipboard_cmd();
        //  return;
        //}
        if (flags.get_clipboard_info_flag === false ||
          flags.is_valid_verson === false ||
          cmd_info === null ||
          jserror_cache.length === 0) {
          return;
        }
        var jserror_count = jserror_cache.length;
        var request_data = {
          testid: cmd_info.testid,
          deviceid: cmd_info.deviceid,
          data: JSON.stringify(jserror_cache)
        };
        var request_header = {};

        if (typeof (cmd_info.sessionid) != 'undefined') {
          request_header.Cookie = cmd_info.sessionid;
        }
        if (typeof (cmd_info.token) != 'undefined' && typeof (cmd_info.time) != 'undefined') {
          request_data.token = cmd_info.token;
          request_data.time = cmd_info.time;
        }

        wx.request({
          url: FPSStats.WETEST_MINIGAMEJSERROR_API_URL,
          data: request_data,
          method: 'POST',
          header: request_header,
          success(res) {
            if (res.data['flag'] == true) {
              //console.log("wetest api request success");
              // jserror_cache = [];
              jserror_cache = jserror_cache.slice(jserror_count);
            } else {
              wx.showToast({
                title: 'wetest jserror api fail, msg:' + res.data['msg'],
                icon: 'none'
              });
              //console.log("wetest api request fail1, res:" + res.data);
            }
          },
          fail(res) {
            wx.showToast({
              title: 'wetest jserror api request fail',
              icon: 'none'
            });
            //console.log("wetest api request fail2, res:" + res.data);
          }
        });
      },

      send_jserror: function (timestamp, jserror) {
        var jserror_info = { "timestamp": timestamp, "jserror": jserror };
        if (jserror_cache.length >= jserror_cache_size) {
          jserror_cache.shift();
          jserror_cache.push(jserror_info);
          //console.log("send_jserror: reach cache size, shift and push jserror");
        } else {
          jserror_cache.push(jserror_info);
          //console.log("send_jserror: push jserror");
        }
      },

        /* fps stat start entrance */
        start: function () {
            var that = this;
            if (that.mode === FPSStats.MODE_STAT) {
                return 0;
            }

            that.init();

            // 开启统计FPS循环
            function animate() {
                if (that.mode === FPSStats.MODE_STAT){
                    that.calc();
                    requestAnimationFrame(animate);
                }
            }
            animate();

            var jserror_callback = function (error) {
              that.send_jserror(Date.now(), error.message);
            }
            wx.onError(jserror_callback);

            setInterval(that.send_jserror_data_to_wetest, 5000);
        },

        /* fps stat stop */
        stop: function () {
            this.mode = FPSStats.MODE_STOP;
        }
    };
};

/* constants */
FPSStats.MODE_STAT = 0x00;
FPSStats.MODE_STOP = 0x01;
FPSStats.MODE_INIT = 0x02;
FPSStats.WETEST_FPS_API_URL = 'https://wetest.qq.com/cloud/api/miniappFps';
FPSStats.FPS_CHACE_SIZE = 100;
FPSStats.WETEST_MINIGAMEJSERROR_API_URL = 'https://wetest.qq.com/cloud/api/miniappError';
FPSStats.JSERROR_CACHE_SIZE = 100;

FPSStats.WETEST_SDK_VERSION_URL = 'https://wetest.qq.com/cloud/api/jsSdkVersion';
FPSStats.version = '1.0';

var check_whitelist = function () {
  console.log("fffff")
  wx.request({
    url: FPSStats.WETEST_FPS_API_URL,
    method: 'GET',
    success(res) {
      console.log("wetest api request success")
      wx.showModal({
        title: 'wetest白名单检测',
        content: '已添加wetest白名单',
        showCancel: false
      })

    },
    fail(res) {
      console.log("wetest api request fail")
      wx.showModal({
        title: 'wetest白名单检测',
        content: '未添加wetest白名单，请提醒开发配置',
        showCancel: false
      })
    }
  })
}
check_whitelist()

// start running
if (!argusFpsStats) {
    var argusFpsStats = new FPSStats();
}
argusFpsStats.start();
